/*
 * simco_nb.h
 *
 * Copyright (C) 2005, Ranch Networks, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * Author : Srivatsa Chivukula <srivatsa@ranchnetworks.com>
 *
 */

#ifndef SIMCO_NB_H
#define SIMCO_NB_H

typedef struct _callbackList {
  int sock;
  int tid;
  unsigned char request_subtype;
  int ttl;
} callbackList;

extern callbackList callback_list[];

extern int nb_init(void);
extern void nb_destroy(void);

extern void register_callback(MCAgentCon *con, unsigned int tid, char subtype, int timeout);
extern void deregister_callback(int index);

extern int nb_mcAgentTCPSessionEstablish(MCAgentCon *con);
extern int nb_mcAgentTCPSessionAuthenticate(MCAgentCon *con, char *username, char *password);
extern int nb_mcAgentTCPSessionTerminate(MCAgentCon *con);
extern int nb_mcAgentTCPPing(MCAgentCon *con);
extern int nb_mcAgentTCPPolicyReserveRule(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPolicyEnableRule(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPERAfterReservation(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPBRAfterReservation(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPolicyRuleLifetimeChange(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPolicyRuleStatus(MCAgentCon *con, simcoPacket_t *sp);
extern int nb_mcAgentTCPPolicyRuleList(MCAgentCon *con);

extern int print_callback_list(void);

#endif /* SIMCO_NB_H */
